"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _fullscreen = _interopRequireDefault(require("../../utils/fullscreen"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var propTypes = {
  actions: _propTypes["default"].object,
  player: _propTypes["default"].object,
  className: _propTypes["default"].string,
  fullscreenElement: _propTypes["default"].any
};

var FullscreenToggle = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(FullscreenToggle, _Component);

  var _super = _createSuper(FullscreenToggle);

  function FullscreenToggle(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, FullscreenToggle);
    _this = _super.call(this, props);
    _this.handleClick = _this.handleClick.bind((0, _assertThisInitialized2["default"])(_this));
    _this.handleFullScreenChange = _this.handleFullScreenChange.bind((0, _assertThisInitialized2["default"])(_this));
    return _this;
  }

  (0, _createClass2["default"])(FullscreenToggle, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      _fullscreen["default"].addEventListener(this.handleFullScreenChange);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      _fullscreen["default"].removeEventListener(this.handleFullScreenChange);
    }
  }, {
    key: "handleFullScreenChange",
    value: function handleFullScreenChange(event) {
      var _this$props = this.props,
          fullscreenElement = _this$props.fullscreenElement,
          actions = _this$props.actions;

      if (event.target === fullscreenElement) {
        actions.handleFullscreenChange(_fullscreen["default"].isFullscreen);
      }
    }
  }, {
    key: "handleClick",
    value: function handleClick() {
      var _this$props2 = this.props,
          player = _this$props2.player,
          actions = _this$props2.actions,
          fullscreenElement = _this$props2.fullscreenElement;
      actions.toggleFullscreen(player, fullscreenElement);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props3 = this.props,
          player = _this$props3.player,
          className = _this$props3.className;
      return /*#__PURE__*/_react["default"].createElement("button", {
        className: (0, _classnames["default"])(className, {
          'cueplayer-react-icon-fullscreen-exit': player.isFullscreen,
          'cueplayer-react-icon-fullscreen': !player.isFullscreen
        }, 'cueplayer-react-fullscreen-control cueplayer-react-control cueplayer-react-button cueplayer-react-icon'),
        ref: function ref(c) {
          _this2.button = c;
        },
        type: "button",
        tabIndex: "0",
        onClick: this.handleClick
      }, /*#__PURE__*/_react["default"].createElement("span", {
        className: "cueplayer-react-control-text"
      }, "Non-Fullscreen"));
    }
  }]);
  return FullscreenToggle;
}(_react.Component);

exports["default"] = FullscreenToggle;
FullscreenToggle.propTypes = propTypes;
FullscreenToggle.displayName = 'FullscreenToggle';