"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _isEmpty = _interopRequireDefault(require("lodash/isEmpty"));

var _useCue = require("./use-cue");

var CueBar = function CueBar(_ref) {
  var className = _ref.className,
      disableCompletely = _ref.disableCompletely,
      player = _ref.player,
      actions = _ref.actions;
  var duration = player.duration,
      activeMetadataTracks = player.activeMetadataTracks;
  var noteTracks = activeMetadataTracks.filter(function (track) {
    return track.label === 'notes';
  });
  var noteCues = noteTracks.reduce(function (acc, track) {
    return [].concat((0, _toConsumableArray2["default"])(acc), (0, _toConsumableArray2["default"])(Array.from(track.cues || [])));
  }, []);
  disableCompletely = disableCompletely || (0, _isEmpty["default"])(noteCues);
  return disableCompletely ? null : /*#__PURE__*/React.createElement("div", {
    className: (0, _classnames["default"])('cueplayer-react-cue-bar', className)
  }, noteCues.map(function (noteCue) {
    return /*#__PURE__*/React.createElement(NoteCue, {
      key: noteCue.text,
      cue: noteCue,
      duration: duration,
      player: player,
      actions: actions
    });
  }));
};

var _default = CueBar;
exports["default"] = _default;

var CuePopup = function CuePopup(_ref2) {
  var cue = _ref2.cue,
      active = _ref2.active;
  var note = JSON.parse(cue.text);
  return active ? /*#__PURE__*/React.createElement("div", {
    className: "cueplayer-react-cue-popup"
  }, note === null || note === void 0 ? void 0 : note.title) : null;
};

var NoteCue = function NoteCue(_ref3) {
  var cue = _ref3.cue,
      duration = _ref3.duration,
      className = _ref3.className,
      actions = _ref3.actions,
      player = _ref3.player;
  var setActive = (0, _useCue.useCue)(cue, actions);

  var _React$useState = React.useState(false),
      _React$useState2 = (0, _slicedToArray2["default"])(_React$useState, 2),
      persist = _React$useState2[0],
      setPersist = _React$useState2[1];

  var active = cue === player.activeMetadataTrackCue;
  var startPosition = "".concat(cue.startTime / duration * 100, "%");
  return /*#__PURE__*/React.createElement("div", {
    className: (0, _classnames["default"])('cueplayer-react-cue-note', {
      'cueplayer-react-cue-note-active': active,
      'cueplayer-react-cue-note-inactive': !active
    }, className),
    style: {
      left: startPosition
    },
    onClick: function onClick() {
      if (active && !persist) {
        setPersist(true);
      } else if (active) {
        setActive(false);
        setPersist(false);
      } else {
        setActive(true);
        setPersist(true);
      }
    },
    onMouseOver: function onMouseOver() {
      return setActive(true);
    },
    onMouseLeave: function onMouseLeave() {
      return !persist && setActive(false);
    }
  }, /*#__PURE__*/React.createElement(CuePopup, {
    cue: cue,
    active: active
  }));
};