"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useCue = void 0;

var React = _interopRequireWildcard(require("react"));

var useCue = function useCue(cue, actions) {
  var setActive = React.useCallback(function setActive(active) {
    if (active) {
      actions.activateMetadataTrackCue(cue);
    } else {
      actions.activateMetadataTrackCue(null);
    }
  }, [actions]);
  React.useEffect(function () {
    var enterCue = function enterCue() {
      setActive(true);
    };

    var exitCue = function exitCue() {
      setActive(false);
    };

    cue.addEventListener('enter', enterCue);
    cue.addEventListener('exit', exitCue);
    return function () {
      cue.removeEventListener('enter', enterCue);
      cue.removeEventListener('exit', exitCue);
    };
  }, [cue, setActive]);
  return setActive;
};

exports.useCue = useCue;