"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var SidePanel = function SidePanel(_ref) {
  var className = _ref.className,
      disableCompletely = _ref.disableCompletely,
      player = _ref.player,
      actions = _ref.actions;
  var duration = player.duration,
      activeMetadataTracks = player.activeMetadataTracks;
  var noteTracks = activeMetadataTracks.filter(function (track) {
    return track.label === 'notes';
  });
  var noteCues = noteTracks.reduce(function (acc, track) {
    return [].concat((0, _toConsumableArray2["default"])(acc), (0, _toConsumableArray2["default"])(Array.from(track.cues || [])));
  }, []);
  return disableCompletely ? null : /*#__PURE__*/React.createElement("div", {
    className: (0, _classnames["default"])('cueplayer-react-side-panel', className)
  }, noteCues.map(function (cue) {
    var note = JSON.parse(cue.text);
    var active = cue === player.activeMetadataTrackCue;
    return /*#__PURE__*/React.createElement("section", {
      className: (0, _classnames["default"])('cueplayer-react-cue-note', {
        'cueplayer-react-cue-note-active': active,
        'cueplayer-react-cue-note-inactive': !active
      }, className)
    }, /*#__PURE__*/React.createElement("h1", {
      className: "font-bold"
    }, note.title), note.description);
  }));
};

var _default = SidePanel;
exports["default"] = _default;